﻿//Utilities class, contains useful functions
//Created May 22, 2007
//Updated July 25, 2007

class Utilities {
	
	//Prevents instantiation
	private function Utilities() {
	}
	
	//If any value in the given array is equal to the given object,
	//the index of that value is returned
	static function getIndex(char:Object, array:Array):Number{
		var i:Number = 0;

		for (i=0; i<array.length; i++) {
			if (array[i] == char) {
				return i;
			}
		}
		return -1;
	}
	
	
	//Takes in a character and an array, returns the number of times
	//that the character is found in the array
	static function arrayContains(char:String, array:Array):Number {
		var found:Number = 0;
		var i:Number = 0;

		for (i=0; i<array.length; i++) {
			if (array[i] == char) {
				found++;
			}
		}
		return found;
	}
	
	//Takes in two arrays, the input array and the possible values array,
	//and returns an array of the indices in the possible values array
	//that are found in the input array.
	static function findDots(dotList:Array, input:Array):Array {
		var i:Number = 0;
		var j:Number = 1;
		var toReturn:Array = new Array();

		//We have:a dotList from 1->6 of the 6 dot positions
		//an input array from 0->n-1 (length = n) of the pressed keys
		if (input.length == 0) {
			return null;
		} else {
			for (i=0; i<input.length; i++) {
				//iterate through the dotList array and find out the indices
				//in the dotList that are selected in the input
				for (j=1; j<dotList.length; j++) {
					if (dotList[j] == input[i]) {
						toReturn.push(j);
					}
				}
			}
		}
		toReturn.sort();
		return toReturn;
	}
	
	//Checks to see if the given string is in the given array
	public static function keysContain(char:String, array:Array):Boolean{
		for (var i = 0; i<array.length; i++){
			if (array[i].getCharName() == char)
				return true;
		}
		return false;
	}
	
}